﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=12.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: true
	#IncludeTitle: false
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private backLabel As B4XView
	Private btnCalc As B4XView
	Private cmbMonth As B4XComboBox
	Private cmbYear As B4XComboBox
	Private lblEntrate As B4XView
	Private lblEntrateTotal As B4XView
	Private lbluscite As B4XView
	Private lblUsciteTotal As B4XView
	
	
	Dim Years() As String = Array As String("2024", "2023", "2022", "2021","2020")
	Dim Months() As String = Array As String("Gennaio", "Febbraio", "Marzo", "Aprile", "Maggio", "Giugno", "Luglio", "Agosto", "Settembre", "Ottobre", "Novembre", "Dicembre")

	Dim result As ResultSet
	Dim query As String
	Dim args() As String
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("LReport")

	cmbMonth.cmbBox.AddAll(Months)
	cmbYear.cmbBox.AddAll(Years)
	
	lblEntrateTotal.text = 0
	lblUsciteTotal.text = 0

End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Private Sub backLabel_Click
	Activity.Finish
End Sub

Private Sub btnCalc_Click
	Dim selectedYear As String
	Dim selectedMonth As String
	Dim TotalAmount As String ' Modificato il tipo di dato in Double
    
	selectedMonth = cmbMonth.SelectedItem
	selectedYear = cmbYear.SelectedItem
    
	Dim monthMap As Map
	monthMap = CreateMonthMap
    
	Dim selectedMonthNumber As String
	selectedMonthNumber = monthMap.Get(selectedMonth)
	lblEntrateTotal.text = 0
	lblUsciteTotal.text = 0
	TotalAmount = 0

    Log($"Selected Month Number: ${selectedMonthNumber}"$)
	Log($"Selected Month: {selectedMonth}"$)
	
	Dim yearSum As ResultSet

	Try
		Dim incomeSum As ResultSet
		query = "SELECT SUM(movImporto) FROM tbl_movimenti WHERE movTipo = ? AND (movCategoria = ? OR movCategoria = ?)  AND movDescrizione NOT LIKE '%saldo%' AND strftime('%Y', datetime(movData / 1000, 'unixepoch')) = ? AND strftime('%m', datetime(movData / 1000, 'unixepoch')) = ?"
		args = Array As String("Entrata","Generale", "Riscossione", selectedYear, selectedMonthNumber)
		incomeSum = Starter.sql.ExecQuery2(query, args)

		Dim expenseSum As ResultSet
		query = "SELECT SUM(movImporto) FROM tbl_movimenti WHERE  movTipo = ? AND (movCategoria = ? OR movCategoria = ?)  AND movDescrizione NOT LIKE '%saldo%' AND strftime('%Y', datetime(movData / 1000, 'unixepoch')) = ? AND strftime('%m', datetime(movData / 1000, 'unixepoch')) = ?"
		args = Array As String("Uscita","Generale", "Prestito",selectedYear, selectedMonthNumber)
		expenseSum = Starter.sql.ExecQuery2(query,args) 

		If incomeSum.NextRow Then
			' Ottenere il valore dalla colonna appropriata, ad esempio:
			Dim incomeValue As Double = incomeSum.GetDouble("SUM(movImporto)")
    
			If incomeValue = 0 Then
				Log("Nessun record trovato per la query di entrate.")
			Else
				' Fai qualcosa con incomeValue, ad esempio aggiorna TotalAmount
				TotalAmount =  incomeValue & " €"
				Log("Entrate TotalAmount aggiornato: " & TotalAmount)
				lblEntrateTotal.text = TotalAmount
			End If
		Else
			Log("Nessun record trovato per la query di entrate.")
		End If

		If expenseSum.NextRow Then
			' Ottenere il valore dalla colonna appropriata, ad esempio:
			Dim expenseValue As Double = expenseSum.GetDouble("SUM(movImporto)")
    
			If expenseValue = 0 Then
				Log("Nessun record trovato per la query di uscite.")
			Else
				' Fai qualcosa con expenseValue, ad esempio aggiorna TotalAmount
				TotalAmount = expenseValue & " €"
				Log("Uscite TotalAmount aggiornato: " & TotalAmount)
				lblUsciteTotal.text = TotalAmount
			End If
		Else
			Log("Nessun record trovato per la query di uscite.")
		End If
	Catch
		Log("Errore nell'esecuzione delle query.")
	
		If incomeSum <> Null Then
			incomeSum.Close
		End If

		If expenseSum <> Null Then
			expenseSum.Close
		End If
	End Try


	
	
	
	
'
'    Dim yearSum As Double
'    yearSum = Starter.sql.ExecQuerySingleResult2("SELECT SUM(movImporto) FROM tbl_movimenti WHERE strftime('%Y', datetime(movData / 1000, 'unixepoch')) = ? AND strftime('%m', datetime(movData / 1000, 'unixepoch')) = ?" , Array As String(selectedYear, selectedMonthNumber))
'    
'    If yearSum = 0 Then
'        Log("Nessun record trovato per la query.")
'    Else
'        TotalAmount = TotalAmount + yearSum
'        Log("TotalAmount aggiornato: " & TotalAmount)
'    End If
End Sub

Sub CreateMonthMap As Map
	Dim monthMap As Map
	monthMap.Initialize
	monthMap.Put("Gennaio", "01")
	monthMap.Put("Febbraio", "02")
	monthMap.Put("Marzo", "03")
	monthMap.Put("Aprile", "04")
	monthMap.Put("Maggio", "05")
	monthMap.Put("Giugno", "06")
	monthMap.Put("Luglio", "07")
	monthMap.Put("Agosto", "08")
	monthMap.Put("Settembre", "09")
	monthMap.Put("Ottobre", "10")
	monthMap.Put("Novembre", "11")
	monthMap.Put("Dicembre", "12")
	Return monthMap
End Sub